program Specificaties;
{ Vul aan op de stippeltjes.  Laat de rest in tact.
  Het moet gewoon compileren.

  Streef er telkens naar zo formeel mogelijke predikaten te geven.
  Gebruik waar mogelijk Pascal notatie.
  Gebruik => voor "impliceert".  N.B. <= betekent "ten hoogste".
  Gebruik (E i: P: Q) voor "Er is een i met P waarvoor Q geldt".
  Gebruik (A i: P: Q) voor "Voor alle i met P geldt Q".
  Gebruik (# i: P: Q) voor "Het aantal i met P waarvoor Q geldt".
  Gebruik (+ i: P: Q) voor "Som over alle i met P van Q".
  Bijv. (+ i: 0 <= i < n: n^3) = (+ i: 0 <= i < n: n)^2 .
}

procedure Snoep ( K, C: Integer; out deelbaar: Boolean; out Q: Integer );
{ Zie opgave Snoep. }
{ pre:  ...
  post: ...
}
begin
end;

var
  d: Boolean; { voor resultaat van Snoep }
  q: Integer; { voor resultaat van Snoep }

{ Na aanroep van Snoep ( 3, 15, d, q ) geldt ... }
{ Na aanroep van Snoep ( 2, 7, d, q ) geldt ... }
{ Na aanroep van Snoep ( 1, 0, d, q ) geldt ... }

procedure BepaalMediaan ( a, b, c: Integer; out m: Integer );
{ Zie opgave Mediaan. }
{ pre:  ...
  post: ...
}
begin
end;

function Mediaan ( a, b, c: Integer ): Integer;
{ Zie opgave Mediaan. }
{ pre: ...
  ret: m zodanig dat ...
}
begin
end;

procedure Flip ( var a, b: Integer );
{ Verwissel a en b van waarde als a > b. }
{ Gebruik "old a" voor "waarde van a in preconditie". }
{ pre:  ...
  post: ...
}
begin
end;

const
  Niemand = 0; { fictief spelersnummer om "niemand" aan te duiden }
  NSpelers = 5; { aantal spelers }
  MaxWaarde = 12; { maximale worpwaarde }

type
  Waarde = 1 .. MaxWaarde; { worpwaarde }
  Speler = Niemand .. NSpelers; { de spelers }
  WorpLijst = array [ 1 .. NSpelers ] of Waarde; { worp van elke speler }

function MaxWorp ( const wl: WorpLijst ): Waarde;
{ Retourneer maximum worp. }
{ pre: ...
  ret: ...
}
begin
end;

procedure Dobbelronde ( const wl: WorpLijst; out winnaar: Speler );
{ Bepaal winnaar bij worpen wl.  Zie ook opgave Dobbelronde. }
{ pre:  ...
  post: ...
}
begin
end;

function Keizer ( n: QWord ): QWord;
{ Wie keizer wordt bij n kandidaten.  Zie opgave Kies de keizer. }
{ N.B. QWord is het type 0 .. 18446744073709551615 }
{ pre: ...
  ret: ...
}
begin
end;

type
  TLetter = 'a' .. 'z'; { de letters }
  THistogramL = array [ TLetter ] of Cardinal; { frequentie per letter }

procedure Turven ( const s: String; out freq: THistogramL );
{ Turf letterfrequenties in s.  Zie opgave Letters turven. }
{ pre:  ...
  post: ...
}
begin
end;

type
  THistogramS = array [ Speler ] of Cardinal; { frequentie per speler }

procedure Dobbelsimulatie ( n: Integer; out winst: THistogramS );
{ Bepaal winstfrequenties bij simulatie van n ronden.
  Zie ook opgave Dobbelsimulatie. }
{ pre:  ...
  post: ...
}
begin
end;

function CijferWaarde ( c: Char ): Integer;
{ Zie opgave ISBN13. }
{ pre: ...
  ret: ...
}
begin
end;

function GeldigISBN13 ( const code: String ): Boolean;
{ Zie opgave ISBN-13 Controleren. }
{ pre: ...
  ret: ...
}
begin
end;

begin
end.
